// test_obj_saioled.ino 
// Test des objets sai_oled et menu_oled
// Castoo https://castoo.fr
// Décembre 2019

#include "SSD1306Wire.h"
#include "sai_oled.h"
#include "menu_oled.h"

// l'adresse I2C (ici 0x3C) peut être différente en fonction du module utilisé
//SSD1306Wire  display(0x3c, 4, 5); // I2C sur un esp8266 donc gpio 4 > SDA & gpio 5 > SCL
SSD1306Wire  display(0x3c, 15, 14); // I2C sur un esp8266 donc gpio 4 > SDA & gpio 5 > SCL
// Pour initialiser les objets sai_oled et menu_oled il faut passer les sorties Gpio utilisées pour le bouton rotatif
// Il est également necessaire de preciser le nom de l'objet écran utilisé (celui-ci peut facilement être modifié)
//sai_oled mon_sai_oled(16, 13, 0, display); // init saisie (Gpio vclk, Gpio vdt, Gpio vsw et nom de l'objet LCD)
sai_oled mon_sai_oled(3, 13, 1, display); // init saisie (Gpio vclk, Gpio vdt, Gpio vsw et nom de l'objet LCD)
//menu_oled mes_menus_oled(16, 13, 0, display); // init saisie (Gpio vclk, Gpio vdt, Gpio vsw et nom de l'objet LCD)
menu_oled mes_menus_oled(3, 13, 1, display); // init saisie (Gpio vclk, Gpio vdt, Gpio vsw et nom de l'objet LCD)
//uint8_t PinSW = 0;  // Gpio x sur sortie SW du selecteur rotatif sera utilisée pour valider les delais d'attente
uint8_t PinSW = 1;  // Gpio x sur sortie SW du selecteur rotatif sera utilisée pour valider les delais d'attente

int B_menu; // Choix selectionné dans menu
const int nb_ch_menuA = 3; // choix du menu Principal
const String ch_menuA[] = {"Saisir votre nom", "Saisir votre prénom", "Afficher Nom Prénom"};
String _ch_menuA = * ch_menuA;
String nom = "";
String prenom = "";
String ch_result = "";

// Initialisation
void setup() { 
	pinMode(PinSW, INPUT); // Sortie SW du selecteur rotatif
	// Init OLED
	display.init();
	display.flipScreenVertically();
	display.setFont(ArialMT_Plain_24);
	display.setTextAlignment(TEXT_ALIGN_CENTER);
	display.clear();
	// Init des objets sai_oled
	mon_sai_oled.init(); // Initialisation ecran pour saisie OLED
	mon_sai_oled.sortie_deb(false); // Invalide sortie balayage aprés chaque saisie (+ rapide mais perso, j'aime pas !) à tester à true...
} 

// Boucle principale
void loop(){
	delay(200);
	B_menu = 0;
	B_menu = mes_menus_oled.init(nb_ch_menuA, _ch_menuA);
	delay(300);
	if (B_menu == 0) {
		// Saisie du nom
		mon_sai_oled.init(); // Initialisation ecran OLED pour saisie
		nom = mon_sai_oled.aff_menu_Alpha(); // On lance la saisie
	}
	else if (B_menu == 1) {
		// Saisie du prénom
		mon_sai_oled.init(); // Initialisation ecran OLED pour saisie
		prenom = mon_sai_oled.aff_menu_Alpha(); // On lance la saisie
	}
	else if (B_menu == 2) {
		// Affichage du nom et du prénom
		delay(200); // Anti rebond bouton
		ch_result = nom + " " + prenom;
		if(ch_result == " ") ch_result = "Vous devez faire une saisie !";
		display.setFont(ArialMT_Plain_10);
		display.setTextAlignment(TEXT_ALIGN_CENTER);
		display.clear();
		display.drawString(64, 25, ch_result);
		display.display();
		while(digitalRead(PinSW)){delay(10);} // On attend que le bouton soit pressé pour sortir de l'affichage
		delay(400);
	}
}
